;;; -*-Scheme-*-
;;;
;;; $Id: sos.sch,v 1.7 1993/02/27 01:33:56 cph Exp $
;;;
;;; Copyright (c) 1993 Massachusetts Institute of Technology
;;;
;;; This material was developed by the Scheme project at the
;;; Massachusetts Institute of Technology, Department of Electrical
;;; Engineering and Computer Science.  Permission to copy this
;;; software, to redistribute it, and to use it for any purpose is
;;; granted, subject to the following restrictions and understandings.
;;;
;;; 1. Any copy made of this software must include this copyright
;;; notice in full.
;;;
;;; 2. Users of this software agree to make their best efforts (a) to
;;; return to the MIT Scheme project any improvements or extensions
;;; that they make, so that these may be included in future releases;
;;; and (b) to inform MIT of noteworthy uses of this software.
;;;
;;; 3. All materials developed as a consequence of the use of this
;;; software shall duly acknowledge such use, in accordance with the
;;; usual standards of acknowledging credit in academic research.
;;;
;;; 4. MIT has made no warrantee or representation that the operation
;;; of this software will be error-free, and MIT is under no
;;; obligation to provide any services, by way of maintenance, update,
;;; or otherwise.
;;;
;;; 5. In conjunction with products arising from the use of this
;;; material, there shall be no use of the name of the Massachusetts
;;; Institute of Technology nor of any adaptation thereof in any
;;; advertising, promotional, or sales literature without prior
;;; written consent from MIT in each case.

;;;; Module Signature of Scheme Object System

(define-external <boolean> sos)
(define-external <char> sos)
(define-external <class> sos)
(define-external <complex> sos)
(define-external <exact-complex> sos)
(define-external <exact-integer> sos)
(define-external <exact-rational> sos)
(define-external <exact-real> sos)
(define-external <exact> sos)
(define-external <fixed> sos)
(define-external <float-integer> sos)
(define-external <float> sos)
(define-external <generic-procedure> sos)
(define-external <generic> sos)
(define-external <inexact-complex> sos)
(define-external <inexact-integer> sos)
(define-external <inexact-rational> sos)
(define-external <inexact-real> sos)
(define-external <inexact> sos)
(define-external <instance> sos)
(define-external <integer> sos)
(define-external <math-object> sos)
(define-external <method> sos)
(define-external <number> sos)
(define-external <object> sos)
(define-external <pair> sos)
(define-external <primitive-class> sos)
(define-external <procedure-class> sos)
(define-external <procedure> sos)
(define-external <rational> sos)
(define-external <real> sos)
(define-external <record> sos)
(define-external <string> sos)
(define-external <symbol> sos)
(define-external <vector> sos)
(define-external (add-method generic-procedure method) sos)
(define-external allocate-instance sos)
(define-external class-direct-superclasses sos)
(define-external class-name sos)
(define-external class-precedence-list sos)
(define-external (class? object) sos)
(define-external compute-apply-generic sos)
(define-external compute-effective-method-procedure sos)
(define-external compute-method-more-specific? sos)
(define-external compute-methods sos)
(define-external compute-precedence-list sos)
(define-external compute-slot-descriptor sos)
(define-external compute-slots sos)
(define-external compute-virtual-slot-accessors sos)
(define-external (error:uninitialized-instance-slot instance slot) sos)
(define-external generic->procedure sos)
(define-external generic-max-arity sos)
(define-external generic-methods sos)
(define-external generic-min-arity sos)
(define-external generic-name sos)
(define-external (generic-procedure? object) sos)
(define-external initialize-instance sos)
(define-external (instance-class instance) sos)
(define-external (instance-of? instance) sos)
(define-external (instance? object) sos)
(define-external (make-class name direct-superclasses direct-slots) sos)
(define-external (make-generic-procedure name min-arity max-arity) sos)
(define-external (make-instance class . initargs) sos)
(define-external (make-method specializers procedure) sos)
(define-external (make-slot name class allocation initializer plist) sos)
(define-external method-procedure sos)
(define-external method-specializers sos)
(define-external (object-class object) sos)
(define-external (ppi object) sos)
(define-external (procedure->generic procedure) sos)
(define-external (set-slot-value! instance name value) sos)
(define-external (slot-accessor name) sos)
(define-external slot-accessor-method sos)
(define-external (slot-allocation slot) sos)
(define-external (slot-class slot) sos)
(define-external (slot-descriptor instance name) sos)
(define-external (slot-descriptors class) sos)
(define-external (slot-initialized? instance name) sos)
(define-external (slot-initializer slot) sos)
(define-external (slot-initpred name) sos)
(define-external slot-initpred-method sos)
(define-external (slot-modifier name) sos)
(define-external slot-modifier-method sos)
(define-external (slot-name slot) sos)
(define-external (slot-plist slot) sos)
(define-external (slot-plist-lookup plist key default) sos)
(define-external (slot-property slot name . default) sos)
(define-external (slot-value instance name) sos)
(define-external (slot? object) sos)
(define-external write-instance sos)
(define-external (write-instance-helper name object port thunk) sos)

(include "macros.sch")

(eval-when (compile)
  (loadq "mitutil.sc")
  (loadq "macros.sc"))